# syntax=docker-registry.wikimedia.org/repos/releng/blubber/buildkit:v0.22.0
# SPDX-License-Identifier: Apache-2.0
version: v4
base: docker-registry.wikimedia.org/bookworm:latest
lives:
  as: pgbouncer
  in: /opt/pgbouncer
variants:
  pgbouncer-source:
    lives:
      in: /usr/src/pgbouncer
    apt:
      packages:
        - wget
    builders:
      - custom:
          command: [ 'wget', 'http://www.pgbouncer.org/downloads/files/1.22.1/pgbouncer-1.22.1.tar.gz' ]
      - custom:
          command: [ 'wget', 'http://www.pgbouncer.org/downloads/files/1.22.1/pgbouncer-1.22.1.tar.gz.sha256' ]
      - custom:
          command: [ 'cat pgbouncer-1.22.1.tar.gz.sha256 pgbouncer-1.22.1.tar.gz | sha256sum --check --status' ]
      - custom:
          command: [ 'tar', 'xzf', 'pgbouncer-1.22.1.tar.gz' ]

  pgbouncer-build:
    lives:
      in: /usr/src/pgbouncer
    apt:
      packages:
        - build-essential
        - libc-ares-dev
        - libevent-dev
        - libssl-dev
        - libudns-dev
        - make
        - pkg-config
        - openssl
    builders:
      - custom:
          command: [ './configure' ]
          requirements:
            - from: pgbouncer-source
              source: /usr/src/pgbouncer/pgbouncer-1.22.1
              destination: /usr/src/pgbouncer
      - custom:
          command: [ 'make' ]
    
  production:
    apt:
      packages:
        - libc-ares2
        - libevent-2.1-7
        - wmf-certificates
    copies:
      - from: pgbouncer-build
        source: /usr/src/pgbouncer/pgbouncer
        destination: /usr/bin
      - from: pgbouncer-build
        source: /usr/src/pgbouncer/etc/pgbouncer-minimal.ini
        destination: /etc/pgbouncer/pgbouncer.ini
      - from: pgbouncer-build
        source: /usr/src/pgbouncer/etc/userlist.txt
        destination: /etc/pgbouncer/
    entrypoint: [ '/usr/bin/pgbouncer', '/etc/pgbouncer/pgbouncer.ini' ]
